/*
 * See the NOTICE file distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.xwiki.url;

import org.xwiki.component.annotation.ComponentRole;

/**
 * Transforms a XWiki URL instance into some other representation.
 * 
 * @version $Id: b6c206b33000a566e4479a6c05f7ab2dcc0d97e2 $
 * @since 2.0M1
 * @param <T> the output type
 */
@ComponentRole
public interface XWikiURLSerializer<T>
{
    /**
     * Transforms a XWiki URL instance into some other representation.
     * 
     * @param xwikiURL the XWiki URL to transform
     * @return the new representation
     */
    T serialize(XWikiURL xwikiURL);
}
